<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- creator-mobile-app-tutorial.qdoc -->
  <title>Creating a Mobile Application | Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qt Creator Manual</a></td><td >Creating a Mobile Application</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="index.html">Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="creator-writing-program.html" />
  <link rel="next" href="creator-project-managing.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="creator-writing-program.html">Creating a Qt Widget Based Application</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="creator-project-managing.html">Managing Projects</a>
</p><p/>
<h1 class="title">Creating a Mobile Application</h1>
<span class="subtitle"></span>
<pre class="qml">

  <span class="comment">/****************************************************************************
  **
  ** Copyright (C) 2017 The Qt Company Ltd.
  ** Contact: https://www.qt.io/licensing/
  **
  ** This file is part of Qt Creator
  **
  ** $QT_BEGIN_LICENSE:BSD$
  ** Commercial License Usage
  ** Licensees holding valid commercial Qt licenses may use this file in
  ** accordance with the commercial license agreement provided with the
  ** Software or, alternatively, in accordance with the terms contained in
  ** a written agreement between you and The Qt Company. For licensing terms
  ** and conditions see https://www.qt.io/terms-conditions. For further
  ** information use the contact form at https://www.qt.io/contact-us.
  **
  ** BSD License Usage
  ** Alternatively, you may use this file under the terms of the BSD license
  ** as follows:
  **
  ** &quot;Redistribution and use in source and binary forms, with or without
  ** modification, are permitted provided that the following conditions are
  ** met:
  **   * Redistributions of source code must retain the above copyright
  **     notice, this list of conditions and the following disclaimer.
  **   * Redistributions in binary form must reproduce the above copyright
  **     notice, this list of conditions and the following disclaimer in
  **     the documentation and/or other materials provided with the
  **     distribution.
  **   * Neither the name of The Qt Company Ltd nor the names of its
  **     contributors may be used to endorse or promote products derived
  **     from this software without specific prior written permission.
  **
  **
  ** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  ** &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  ** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  ** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  ** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  ** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  ** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  ** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  ** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  ** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  ** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.&quot;
  **
  ** $QT_END_LICENSE$
  **
  ****************************************************************************/</span>

  import QtQuick 2.9
  import QtQuick.Controls 2.2
  import QtSensors 5.9

  <span class="type"><a href="http://doc.qt.io/qt-5/qml-qtquick-controls2-applicationwindow.html">ApplicationWindow</a></span> {
      <span class="name">visible</span>: <span class="number">true</span>
      <span class="name">width</span>: <span class="number">640</span>
      <span class="name">height</span>: <span class="number">480</span>
      <span class="name">title</span>: <span class="name">qsTr</span>(<span class="string">&quot;Accelerate Bubble&quot;</span>)

      <span class="type"><a href="http://doc.qt.io/qt-5/qml-qtquick-controls2-swipeview.html">SwipeView</a></span> {
          <span class="name">id</span>: <span class="name">swipeView</span>
          <span class="name">anchors</span>.fill: <span class="name">parent</span>
          <span class="name">currentIndex</span>: <span class="name">tabBar</span>.<span class="name">currentIndex</span>

          <span class="type">Page1Form</span> {
              <span class="type">bubble</span> {
                  <span class="name">id</span>: <span class="name">bubble</span>
                  <span class="name">centerX</span>: <span class="name">mainWindow</span>.<span class="name">width</span> <span class="operator">/</span> <span class="number">2</span>
                  <span class="name">centerY</span>: <span class="name">mainWindow</span>.<span class="name">height</span> <span class="operator">/</span> <span class="number">2</span>
                  <span class="name">bubbleCenter</span>: <span class="name">bubble</span>.<span class="name">width</span> <span class="operator">/</span> <span class="number">2</span>
                  <span class="name">x</span>: <span class="name">bubble</span>.<span class="name">centerX</span> <span class="operator">-</span> <span class="name">bubble</span>.<span class="name">bubbleCenter</span>
                  <span class="name">y</span>: <span class="name">bubble</span>.<span class="name">centerY</span> <span class="operator">-</span> <span class="name">bubble</span>.<span class="name">bubbleCenter</span>

                  Behavior on <span class="name">y</span> {
                      <span class="type"><a href="http://doc.qt.io/qt-5/qml-qtquick-smoothedanimation.html">SmoothedAnimation</a></span> {
                          <span class="name">easing</span>.type: <span class="name">Easing</span>.<span class="name">Linear</span>
                          <span class="name">duration</span>: <span class="number">100</span>
                      }
                  }
                  Behavior on <span class="name">x</span> {
                      <span class="type"><a href="http://doc.qt.io/qt-5/qml-qtquick-smoothedanimation.html">SmoothedAnimation</a></span> {
                          <span class="name">easing</span>.type: <span class="name">Easing</span>.<span class="name">Linear</span>
                          <span class="name">duration</span>: <span class="number">100</span>
                      }
                  }
              }
          }

          <span class="type">Page2Form</span> {
          }
      }

      <span class="name">footer</span>: <span class="name">TabBar</span> {
          <span class="name">id</span>: <span class="name">tabBar</span>
          <span class="name">currentIndex</span>: <span class="name">swipeView</span>.<span class="name">currentIndex</span>

          <span class="type"><a href="http://doc.qt.io/qt-5/qml-qtquick-controls2-tabbutton.html">TabButton</a></span> {
              <span class="name">text</span>: <span class="name">qsTr</span>(<span class="string">&quot;Page 1&quot;</span>)
          }
          <span class="type"><a href="http://doc.qt.io/qt-5/qml-qtquick-controls2-tabbutton.html">TabButton</a></span> {
              <span class="name">text</span>: <span class="name">qsTr</span>(<span class="string">&quot;Page 2&quot;</span>)
          }
      }

      <span class="type"><a href="http://doc.qt.io/qt-5/qml-qtsensors-accelerometer.html">Accelerometer</a></span> {
         <span class="name">id</span>: <span class="name">accel</span>
         <span class="name">dataRate</span>: <span class="number">100</span>
         <span class="name">active</span>: <span class="number">true</span>

         <span class="name">onReadingChanged</span>: {
             var newX = (<span class="name">bubble</span>.<span class="name">x</span> <span class="operator">+</span> <span class="name">calcRoll</span>(<span class="name">accel</span>.<span class="name">reading</span>.<span class="name">x</span>, <span class="name">accel</span>.<span class="name">reading</span>.<span class="name">y</span>, <span class="name">accel</span>.<span class="name">reading</span>.<span class="name">z</span>) <span class="operator">*</span> <span class="number">0.1</span>)
             var newY = (<span class="name">bubble</span>.<span class="name">y</span> <span class="operator">-</span> <span class="name">calcPitch</span>(<span class="name">accel</span>.<span class="name">reading</span>.<span class="name">x</span>, <span class="name">accel</span>.<span class="name">reading</span>.<span class="name">y</span>, <span class="name">accel</span>.<span class="name">reading</span>.<span class="name">z</span>) <span class="operator">*</span> <span class="number">0.1</span>)

             <span class="keyword">if</span> (<span class="name">isNaN</span>(<span class="name">newX</span>) <span class="operator">||</span> <span class="name">isNaN</span>(<span class="name">newY</span>))
                 <span class="keyword">return</span>;

             <span class="keyword">if</span> (<span class="name">newX</span> <span class="operator">&lt;</span> <span class="number">0</span>)
                 <span class="name">newX</span> <span class="operator">=</span> <span class="number">0</span>

             <span class="keyword">if</span> (<span class="name">newX</span> <span class="operator">&gt;</span> <span class="name">mainWindow</span>.<span class="name">width</span> <span class="operator">-</span> <span class="name">bubble</span>.<span class="name">width</span>)
                 <span class="name">newX</span> <span class="operator">=</span> <span class="name">mainWindow</span>.<span class="name">width</span> <span class="operator">-</span> <span class="name">bubble</span>.<span class="name">width</span>

             <span class="keyword">if</span> (<span class="name">newY</span> <span class="operator">&lt;</span> <span class="number">18</span>)
                 <span class="name">newY</span> <span class="operator">=</span> <span class="number">18</span>

             <span class="keyword">if</span> (<span class="name">newY</span> <span class="operator">&gt;</span> <span class="name">mainWindow</span>.<span class="name">height</span> <span class="operator">-</span> <span class="name">bubble</span>.<span class="name">height</span>)
                 <span class="name">newY</span> <span class="operator">=</span> <span class="name">mainWindow</span>.<span class="name">height</span> <span class="operator">-</span> <span class="name">bubble</span>.<span class="name">height</span>

                 <span class="name">bubble</span>.<span class="name">x</span> <span class="operator">=</span> <span class="name">newX</span>
                 <span class="name">bubble</span>.<span class="name">y</span> <span class="operator">=</span> <span class="name">newY</span>
         }
     }

      <span class="keyword">function</span> <span class="name">calcPitch</span>(x, y, z) {
          <span class="keyword">return</span> -(<span class="name">Math</span>.<span class="name">atan</span>(<span class="name">y</span> <span class="operator">/</span> <span class="name">Math</span>.<span class="name">sqrt</span>(<span class="name">x</span> <span class="operator">*</span> <span class="name">x</span> <span class="operator">+</span> <span class="name">z</span> <span class="operator">*</span> <span class="name">z</span>)) <span class="operator">*</span> <span class="number">57.2957795</span>);
      }
      <span class="keyword">function</span> <span class="name">calcRoll</span>(x, y, z) {
          <span class="keyword">return</span> -(<span class="name">Math</span>.<span class="name">atan</span>(<span class="name">x</span> <span class="operator">/</span> <span class="name">Math</span>.<span class="name">sqrt</span>(<span class="name">y</span> <span class="operator">*</span> <span class="name">y</span> <span class="operator">+</span> <span class="name">z</span> <span class="operator">*</span> <span class="name">z</span>)) <span class="operator">*</span> <span class="number">57.2957795</span>);
      }
  }

</pre>
